---
product: "AG Charts"
title: "Series Markers"
description: "Data points can be represented by markers in many series types, including line , area , scatter , and bubble ."
framework: javascript
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/stylers/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-labels/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Markers

Data points can be represented by markers in many series types, including `line`, `area`, `scatter`, and `bubble`.

Marker attributes such as `shape`, `size`, `fill` and `stroke` are configurable within each series.

These options are identical across series types, but differ in their location. Series without lines, such as `scatter` and `bubble` have these options on the series level, otherwise they are contained within the `marker` property.

```js
{
    series: [
        {
            // ...
            marker: {
                shape: 'square', // defaults to 'circle'
                size: 20,
                fill: 'red',
                stroke: 'maroon',
            },
        },
    ],
}
```

Please see the [API reference](https://www.ag-grid.com/charts/archive/14.2.0/javascript/markers/#api-reference) for the list of all available options.

### Marker Shape, Size and Colour

#### Marker Shape, Size and Colour

```ts
import {
  AgChartOptions,
  AgCharts,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  title: {
    text: "Fuel Spending (2019)",
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "quarter",
      yKey: "petrol",
      title: "Petrol",
      marker: {
        shape: "square",
        size: 10,
      },
    },
    {
      type: "line",
      xKey: "quarter",
      yKey: "diesel",
      title: "Diesel",
      stroke: "black",
      marker: {
        size: 15,
        fill: "gray",
        stroke: "black",
      },
    },
    {
      type: "line",
      xKey: "quarter",
      yKey: "electric",
      title: "Electric",
      stroke: "#8bc24a",
      marker: {
        shape: "cross",
        size: 20,
        fill: "#8bc24a",
        stroke: "#658d36",
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Marker Shape, Size and Colour](https://www.ag-grid.com/charts/archive/14.2.0/typescript/markers/examples/marker-shape/)

Notice how the shape and colour of the legend markers automatically match the shape and colour of the markers used by the series, but the size of the markers in the legend remains the same.

The legend item marker can be modified within the [Legend Options](https://www.ag-grid.com/charts/archive/14.2.0/javascript/legend/#markers).

## Custom Marker Shapes

You can easily define custom marker shapes by providing a callback function to create the desired shape. This function takes `x` and `y` parameters, representing the marker's position on the canvas, the `size` of the marker and the `path` instance. The path includes various drawing methods that allow you to apply specific drawing commands to construct the marker. If you are familiar with the standard Canvas API, you'll feel right at home here. The `path` API is very similar to that of [CanvasRenderingContext2D](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D).

For example, to draw a heart:

```js
const rad = (degree) => {
    return (degree / 180) * Math.PI;
};

const heart = ({ x, y, path, size }) => {
    const r = size / 4;
    const yCoord = y + r / 2;

    path.clear();
    path.arc(x - r, yCoord - r, r, rad(130), rad(330));
    path.arc(x + r, yCoord - r, r, rad(220), rad(50));
    path.lineTo(x, yCoord + r);
    path.closePath();
};
```

All we do is render two partial circles with the `cubicArc` command and then two straight lines using the `lineTo` and `closePath` commands to get the shape of a heart.

Inside the marker config of a series we then use this callback function rather than using one of the predefined shape names:

```js
{
    marker: {
        shape: heart,
        size: 16,
    },
}
```

The final result is shown in the example below.

#### Custom Marker Shape

```ts
import {
  AgChartOptions,
  AgCharts,
  AgMarkerShapeFnParams,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

const rad = (degree: number) => {
  return (degree / 180) * Math.PI;
};
const heart = ({ x, y, path, size }: AgMarkerShapeFnParams) => {
  const r = size / 4;
  const yCoord = y + r / 2;
  path.clear();
  path.arc(x - r, yCoord - r, r, rad(130), rad(330));
  path.arc(x + r, yCoord - r, r, rad(220), rad(50));
  path.lineTo(x, yCoord + r);
  path.closePath();
};
ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  title: {
    text: "Fuel Spending (2019)",
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "quarter",
      yKey: "electric",
      title: "Electric",
      marker: {
        shape: heart,
        size: 16,
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Custom Marker Shape](https://www.ag-grid.com/charts/archive/14.2.0/typescript/markers/examples/custom-marker/)

## API Reference

#### Series Marker

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show markers. |
| itemStyler | Styler |  | Function used to return formatting for individual markers, based on the supplied information. |
| size | PixelSize |  | The size in pixels of the markers. |
| shape | 'circle' \| 'cross' \| 'diamond' \| 'heart' \| 'plus' \| 'pin' \| 'square' \| 'star' \| 'triangle' \| AgMarkerShapeFn |  | The shape to use for the markers. You can also supply a custom marker by providing a `AgMarkerShapeFn` function. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |


---
product: "AG Charts"
title: "Series Markers"
description: "Data points can be represented by markers in many series types, including line , area , scatter , and bubble ."
framework: vue
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/stylers/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-labels/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Markers

Data points can be represented by markers in many series types, including `line`, `area`, `scatter`, and `bubble`.

Marker attributes such as `shape`, `size`, `fill` and `stroke` are configurable within each series.

These options are identical across series types, but differ in their location. Series without lines, such as `scatter` and `bubble` have these options on the series level, otherwise they are contained within the `marker` property.

```js
{
    series: [
        {
            // ...
            marker: {
                shape: 'square', // defaults to 'circle'
                size: 20,
                fill: 'red',
                stroke: 'maroon',
            },
        },
    ],
}
```

Please see the [API reference](https://www.ag-grid.com/charts/archive/14.2.0/vue/markers/#api-reference) for the list of all available options.

### Marker Shape, Size and Colour

#### Marker Shape, Size and Colour

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "Fuel Spending (2019)",
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "quarter",
          yKey: "petrol",
          title: "Petrol",
          marker: {
            shape: "square",
            size: 10,
          },
        },
        {
          type: "line",
          xKey: "quarter",
          yKey: "diesel",
          title: "Diesel",
          stroke: "black",
          marker: {
            size: 15,
            fill: "gray",
            stroke: "black",
          },
        },
        {
          type: "line",
          xKey: "quarter",
          yKey: "electric",
          title: "Electric",
          stroke: "#8bc24a",
          marker: {
            shape: "cross",
            size: 20,
            fill: "#8bc24a",
            stroke: "#658d36",
          },
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Marker Shape, Size and Colour](https://www.ag-grid.com/charts/archive/14.2.0/vue3/markers/examples/marker-shape/)

Notice how the shape and colour of the legend markers automatically match the shape and colour of the markers used by the series, but the size of the markers in the legend remains the same.

The legend item marker can be modified within the [Legend Options](https://www.ag-grid.com/charts/archive/14.2.0/vue/legend/#markers).

## Custom Marker Shapes

You can easily define custom marker shapes by providing a callback function to create the desired shape. This function takes `x` and `y` parameters, representing the marker's position on the canvas, the `size` of the marker and the `path` instance. The path includes various drawing methods that allow you to apply specific drawing commands to construct the marker. If you are familiar with the standard Canvas API, you'll feel right at home here. The `path` API is very similar to that of [CanvasRenderingContext2D](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D).

For example, to draw a heart:

```js
const rad = (degree) => {
    return (degree / 180) * Math.PI;
};

const heart = ({ x, y, path, size }) => {
    const r = size / 4;
    const yCoord = y + r / 2;

    path.clear();
    path.arc(x - r, yCoord - r, r, rad(130), rad(330));
    path.arc(x + r, yCoord - r, r, rad(220), rad(50));
    path.lineTo(x, yCoord + r);
    path.closePath();
};
```

All we do is render two partial circles with the `cubicArc` command and then two straight lines using the `lineTo` and `closePath` commands to get the shape of a heart.

Inside the marker config of a series we then use this callback function rather than using one of the predefined shape names:

```js
{
    marker: {
        shape: heart,
        size: 16,
    },
}
```

The final result is shown in the example below.

#### Custom Marker Shape

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

const rad = (degree) => {
  return (degree / 180) * Math.PI;
};

const heart = ({ x, y, path, size }) => {
  const r = size / 4;
  const yCoord = y + r / 2;
  path.clear();
  path.arc(x - r, yCoord - r, r, rad(130), rad(330));
  path.arc(x + r, yCoord - r, r, rad(220), rad(50));
  path.lineTo(x, yCoord + r);
  path.closePath();
};

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "Fuel Spending (2019)",
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "quarter",
          yKey: "electric",
          title: "Electric",
          marker: {
            shape: heart,
            size: 16,
          },
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Custom Marker Shape](https://www.ag-grid.com/charts/archive/14.2.0/vue3/markers/examples/custom-marker/)

## API Reference

#### Series Marker

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show markers. |
| itemStyler | Styler |  | Function used to return formatting for individual markers, based on the supplied information. |
| size | PixelSize |  | The size in pixels of the markers. |
| shape | 'circle' \| 'cross' \| 'diamond' \| 'heart' \| 'plus' \| 'pin' \| 'square' \| 'star' \| 'triangle' \| AgMarkerShapeFn |  | The shape to use for the markers. You can also supply a custom marker by providing a `AgMarkerShapeFn` function. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |


Data points can be represented by markers in many series types, including line, area, scatter, and bubble.
Marker attributes such as shape, size, fill and stroke are configurable within each series.
These options are identical across series types, but differ in their location. Series without lines, such as scatter and bubble have these options on the series level, otherwise they are contained within the marker property.
{
series: [
{
// ...
marker: {
shape: 'square', // defaults to 'circle'
size: 20,
fill: 'red',
stroke: 'maroon',
},
},
],
}Please see the API reference for the list of all available options.
Marker Shape, Size and Colour Copy Link
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
ModuleRegistry.registerModules([
CategoryAxisModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: "Fuel Spending (2019)",
},
data: getData(),
series: [
{
type: "line",
xKey: "quarter",
yKey: "petrol",
title: "Petrol",
marker: {
shape: "square",
size: 10,
},
},
{
type: "line",
xKey: "quarter",
yKey: "diesel",
title: "Diesel",
stroke: "black",
marker: {
size: 15,
fill: "gray",
stroke: "black",
},
},
{
type: "line",
xKey: "quarter",
yKey: "electric",
title: "Electric",
stroke: "#8bc24a",
marker: {
shape: "cross",
size: 20,
fill: "#8bc24a",
stroke: "#658d36",
},
},
],
};
}
}
export function getData(): any[] {
return [
{
quarter: "Q1",
petrol: 200,
diesel: 100,
electric: 50,
},
{
quarter: "Q2",
petrol: 300,
diesel: 130,
electric: 60,
},
{
quarter: "Q3",
petrol: 350,
diesel: 160,
electric: 70,
},
{
quarter: "Q4",
petrol: 400,
diesel: 200,
electric: 50,
},
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
Notice how the shape and colour of the legend markers automatically match the shape and colour of the markers used by the series, but the size of the markers in the legend remains the same.
The legend item marker can be modified within the Legend Options.
Custom Marker Shapes Copy Link
You can easily define custom marker shapes by providing a callback function to create the desired shape. This function takes x and y parameters, representing the marker's position on the canvas, the size of the marker and the path instance. The path includes various drawing methods that allow you to apply specific drawing commands to construct the marker. If you are familiar with the standard Canvas API, you'll feel right at home here. The path API is very similar to that of CanvasRenderingContext2D.
For example, to draw a heart:
const rad = (degree) => {
return (degree / 180) * Math.PI;
};
const heart = ({ x, y, path, size }) => {
const r = size / 4;
const yCoord = y + r / 2;
path.clear();
path.arc(x - r, yCoord - r, r, rad(130), rad(330));
path.arc(x + r, yCoord - r, r, rad(220), rad(50));
path.lineTo(x, yCoord + r);
path.closePath();
};All we do is render two partial circles with the cubicArc command and then two straight lines using the lineTo and closePath commands to get the shape of a heart.
Inside the marker config of a series we then use this callback function rather than using one of the predefined shape names:
{
marker: {
shape: heart,
size: 16,
},
}The final result is shown in the example below.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AgMarkerShapeFnParams,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
const rad = (degree: number) => {
return (degree / 180) * Math.PI;
};
const heart = ({ x, y, path, size }: AgMarkerShapeFnParams) => {
const r = size / 4;
const yCoord = y + r / 2;
path.clear();
path.arc(x - r, yCoord - r, r, rad(130), rad(330));
path.arc(x + r, yCoord - r, r, rad(220), rad(50));
path.lineTo(x, yCoord + r);
path.closePath();
};
ModuleRegistry.registerModules([
CategoryAxisModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: "Fuel Spending (2019)",
},
data: getData(),
series: [
{
type: "line",
xKey: "quarter",
yKey: "electric",
title: "Electric",
marker: {
shape: heart,
size: 16,
},
},
],
};
}
}
export function getData(): any[] {
return [
{
quarter: "Q1",
electric: 50,
},
{
quarter: "Q2",
electric: 70,
},
{
quarter: "Q3",
electric: 60,
},
{
quarter: "Q4",
electric: 40,
},
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
API Reference Copy Link
Properties available on the AgSeriesMarkerOptions interface.
- enabled
boolean - Whether to show markers.
- itemStyler
Styler - Function used to return formatting for individual markers, based on the supplied information.
- size
PixelSize - The size in pixels of the markers.
- shape
AgMarkerShape - The shape to use for the markers. You can also supply a custom marker by providing a `AgMarkerShapeFn` function.
- fill
AgColorType - The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill.
- fillOpacity
Opacity - The opacity of the fill colour.
- stroke
AgCssColorOrRef - The colour for the stroke.
- strokeWidth
PixelSize - The width of the stroke in pixels.
- strokeOpacity
Opacity - The opacity of the stroke colour.
- lineDash
PixelSize[] - An array specifying the length in pixels of alternating dashes and gaps.
- lineDashOffset
PixelSize - The initial offset of the dashed line in pixels.
Properties available on the AgSeriesMarkerOptions interface.
- enabled
boolean - Whether to show markers.
- itemStyler
Styler - Function used to return formatting for individual markers, based on the supplied information.
- size
PixelSize - The size in pixels of the markers.
- shape
AgMarkerShape - The shape to use for the markers. You can also supply a custom marker by providing a `AgMarkerShapeFn` function.
- fill
AgColorType - The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill.
- fillOpacity
Opacity - The opacity of the fill colour.
- stroke
AgCssColorOrRef - The colour for the stroke.
- strokeWidth
PixelSize - The width of the stroke in pixels.
- strokeOpacity
Opacity - The opacity of the stroke colour.
- lineDash
PixelSize[] - An array specifying the length in pixels of alternating dashes and gaps.
- lineDashOffset
PixelSize - The initial offset of the dashed line in pixels.

---
product: "AG Charts"
title: "Series Markers"
description: "Data points can be represented by markers in many series types, including line , area , scatter , and bubble ."
framework: react
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/stylers/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-labels/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Markers

Data points can be represented by markers in many series types, including `line`, `area`, `scatter`, and `bubble`.

Marker attributes such as `shape`, `size`, `fill` and `stroke` are configurable within each series.

These options are identical across series types, but differ in their location. Series without lines, such as `scatter` and `bubble` have these options on the series level, otherwise they are contained within the `marker` property.

```js
{
    series: [
        {
            // ...
            marker: {
                shape: 'square', // defaults to 'circle'
                size: 20,
                fill: 'red',
                stroke: 'maroon',
            },
        },
    ],
}
```

Please see the [API reference](https://www.ag-grid.com/charts/archive/14.2.0/react/markers/#api-reference) for the list of all available options.

### Marker Shape, Size and Colour

#### Marker Shape, Size and Colour

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "Fuel Spending (2019)",
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "quarter",
        yKey: "petrol",
        title: "Petrol",
        marker: {
          shape: "square",
          size: 10,
        },
      },
      {
        type: "line",
        xKey: "quarter",
        yKey: "diesel",
        title: "Diesel",
        stroke: "black",
        marker: {
          size: 15,
          fill: "gray",
          stroke: "black",
        },
      },
      {
        type: "line",
        xKey: "quarter",
        yKey: "electric",
        title: "Electric",
        stroke: "#8bc24a",
        marker: {
          shape: "cross",
          size: 20,
          fill: "#8bc24a",
          stroke: "#658d36",
        },
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Marker Shape, Size and Colour](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/markers/examples/marker-shape/)

Notice how the shape and colour of the legend markers automatically match the shape and colour of the markers used by the series, but the size of the markers in the legend remains the same.

The legend item marker can be modified within the [Legend Options](https://www.ag-grid.com/charts/archive/14.2.0/react/legend/#markers).

## Custom Marker Shapes

You can easily define custom marker shapes by providing a callback function to create the desired shape. This function takes `x` and `y` parameters, representing the marker's position on the canvas, the `size` of the marker and the `path` instance. The path includes various drawing methods that allow you to apply specific drawing commands to construct the marker. If you are familiar with the standard Canvas API, you'll feel right at home here. The `path` API is very similar to that of [CanvasRenderingContext2D](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D).

For example, to draw a heart:

```js
const rad = (degree) => {
    return (degree / 180) * Math.PI;
};

const heart = ({ x, y, path, size }) => {
    const r = size / 4;
    const yCoord = y + r / 2;

    path.clear();
    path.arc(x - r, yCoord - r, r, rad(130), rad(330));
    path.arc(x + r, yCoord - r, r, rad(220), rad(50));
    path.lineTo(x, yCoord + r);
    path.closePath();
};
```

All we do is render two partial circles with the `cubicArc` command and then two straight lines using the `lineTo` and `closePath` commands to get the shape of a heart.

Inside the marker config of a series we then use this callback function rather than using one of the predefined shape names:

```js
{
    marker: {
        shape: heart,
        size: 16,
    },
}
```

The final result is shown in the example below.

#### Custom Marker Shape

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AgMarkerShapeFnParams,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

const rad = (degree: number) => {
  return (degree / 180) * Math.PI;
};
const heart = ({ x, y, path, size }: AgMarkerShapeFnParams) => {
  const r = size / 4;
  const yCoord = y + r / 2;
  path.clear();
  path.arc(x - r, yCoord - r, r, rad(130), rad(330));
  path.arc(x + r, yCoord - r, r, rad(220), rad(50));
  path.lineTo(x, yCoord + r);
  path.closePath();
};
ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "Fuel Spending (2019)",
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "quarter",
        yKey: "electric",
        title: "Electric",
        marker: {
          shape: heart,
          size: 16,
        },
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Custom Marker Shape](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/markers/examples/custom-marker/)

## API Reference

#### Series Marker

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show markers. |
| itemStyler | Styler |  | Function used to return formatting for individual markers, based on the supplied information. |
| size | PixelSize |  | The size in pixels of the markers. |
| shape | 'circle' \| 'cross' \| 'diamond' \| 'heart' \| 'plus' \| 'pin' \| 'square' \| 'star' \| 'triangle' \| AgMarkerShapeFn |  | The shape to use for the markers. You can also supply a custom marker by providing a `AgMarkerShapeFn` function. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
